Index: /XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp	(revision 1769)
@@ -18,5 +18,4 @@
   {
     bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
-    // bool building_graph = true;
     int unique_filter_id;
     bool firstround;
@@ -107,5 +106,4 @@
   {
     bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
-    // bool building_graph = true;
     int unique_filter_id;
     bool firstround;
Index: /XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp	(revision 1769)
@@ -500,5 +500,4 @@
   { 
     expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
-    std::cout<<"expression = "<<expression;
     /* Nothing to do */ 
   };
Index: /XIOS/dev/dev_trunk_omp/src/node/field.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/node/field.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/node/field.cpp	(revision 1769)
@@ -1458,5 +1458,5 @@
    TRY
    {
-     if(CXios::isClient) std::cout<<"getSelfReference field_id = "<<this->getId()<<" start_graph = "<<start_graph<<" end_graph = "<<end_graph<<std::endl;
+     //if(CXios::isClient) std::cout<<"getSelfReference field_id = "<<this->getId()<<" start_graph = "<<start_graph<<" end_graph = "<<end_graph<<std::endl;
 
      if (instantDataFilter || !hasExpression())
@@ -1545,5 +1545,8 @@
        
 
-       if(temporalFilter->parent_filters[0]->tag) temporalFilter->tag=true;
+      //  if(temporalFilter->parent_filters[0]->tag) temporalFilter->tag=true;
+      temporalFilter->tag = temporalFilter->parent_filters[0]->tag;
+      temporalFilter->start_graph = temporalFilter->parent_filters[0]->start_graph;
+      temporalFilter->end_graph = temporalFilter->parent_filters[0]->end_graph;
 
        // temporalFilter->start_graph = filter_start;
Index: /XIOS/dev/dev_trunk_omp/src/parse_expr/filter_expr_node.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/parse_expr/filter_expr_node.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/parse_expr/filter_expr_node.cpp	(revision 1769)
@@ -424,5 +424,4 @@
 
     std::shared_ptr<CFieldFieldFieldArithmeticFilter> filter(new CFieldFieldFieldArithmeticFilter(gc, opId));
-    std::cout<<"std::shared_ptr<CFieldFieldFieldArithmeticFilter> filter(new CFieldFieldFieldArithmeticFilter(gc, opId))" <<std::endl;
     ch1->connectOutput(filter, 0);
     ch2->connectOutput(filter, 1);
Index: /XIOS/dev/dev_trunk_omp/src/transformation/Functions/average_reduction.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/Functions/average_reduction.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/Functions/average_reduction.cpp	(revision 1769)
@@ -33,5 +33,4 @@
                                        bool ignoreMissingValue, bool firstPass)
 {
-  std::cout<<"================================ CAverageReductionAlgorithm::apply"<<std::endl;
   if (resetWeight_) { weights_.resize(flagInitial.size()); weights_ = 1.0; resetWeight_ = false; }  
 
Index: /XIOS/dev/dev_trunk_omp/src/transformation/Functions/extract.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/Functions/extract.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/Functions/extract.cpp	(revision 1769)
@@ -32,5 +32,4 @@
                                        bool ignoreMissingValue, bool firstPass)
 {
-  std::cout<<"================================ CExtractReductionAlgorithm::apply"<<std::endl;
   int nbLocalIndex = localIndex.size();
   int currentlocalIndex = 0;
Index: /XIOS/dev/dev_trunk_omp/src/transformation/Functions/max_reduction.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/Functions/max_reduction.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/Functions/max_reduction.cpp	(revision 1769)
@@ -33,5 +33,4 @@
                                    bool ignoreMissingValue, bool firstPass)
 { 
-  std::cout<<"================================ CMaxReductionAlgorithm::apply"<<std::endl;
   if (ignoreMissingValue)
   {
Index: /XIOS/dev/dev_trunk_omp/src/transformation/Functions/min_reduction.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/Functions/min_reduction.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/Functions/min_reduction.cpp	(revision 1769)
@@ -33,5 +33,4 @@
                                    bool ignoreMissingValue, bool firstPass)
 {
-  std::cout<<"================================ CMinReductionAlgorithm::apply"<<std::endl;
   if (ignoreMissingValue)
   {
Index: /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract_domain.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1769)
@@ -81,5 +81,4 @@
 TRY
 {
-  std::cout<<"================================ CAxisAlgorithmExtractDomain::apply"<<std::endl;
   reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
 }
Index: /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_axis.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_axis.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_axis.cpp	(revision 1769)
@@ -88,5 +88,4 @@
 TRY
 {
-  std::cout<<"================================ CAxisAlgorithmReduceAxis::apply"<<std::endl;
   reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
 }
Index: /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_domain.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1769)
@@ -91,5 +91,4 @@
 TRY
 {
-  std::cout<<"================================ CAxisAlgorithmReduceDomain::apply"<<std::endl;
   reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
 }
Index: /XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_interpolate.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_interpolate.cpp	(revision 1769)
@@ -1063,5 +1063,4 @@
 TRY
 {
-  std::cout<<"================================ CDomainAlgorithmInterpolate::apply"<<std::endl;
   int nbLocalIndex = localIndex.size();   
   double defaultValue = std::numeric_limits<double>::quiet_NaN();
Index: /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_extract_axis.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1769)
@@ -69,5 +69,4 @@
 TRY
 {
-  std::cout<<"================================ CScalarAlgorithmExtractAxis::apply"<<std::endl;
   reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
 }
Index: /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1769)
@@ -98,5 +98,4 @@
 TRY
 {
-  std::cout<<"================================ CScalarAlgorithmTransformation::apply"<<std::endl;
   reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
 }
Index: /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_reduce_scalar.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_reduce_scalar.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/transformation/scalar_algorithm_reduce_scalar.cpp	(revision 1769)
@@ -95,5 +95,4 @@
 TRY
 {
-  std::cout<<"================================ CScalarAlgorithmReduceScalar::apply"<<std::endl;
   reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
 }
Index: /XIOS/dev/dev_trunk_omp/src/workflow_graph.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/workflow_graph.cpp	(revision 1768)
+++ /XIOS/dev/dev_trunk_omp/src/workflow_graph.cpp	(revision 1769)
@@ -77,5 +77,4 @@
       for (auto it=mapFilters_ptr_with_info->begin(); it != mapFilters_ptr_with_info->end(); it++)
       {
-        // std::cout<<"it->first = "<<it->first<<std::endl;
         filters[it->first]=it->second.filter_name;
       }