Index: /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/xios-style.css
===================================================================
--- /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/xios-style.css	(revision 1772)
+++ /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/xios-style.css	(revision 1773)
@@ -204,2 +204,35 @@
   .dropdown:hover .dropbtn {background-color:#2e86c1;}
 
+  
+  #compile_table
+  {
+      margin-left: 60px;
+      margin-bottom: 30px;
+      margin-top: 30px;
+      /* border: solid 2px blue; */
+  }
+
+  #compile_table td
+  {
+      margin-left: 20px;
+      margin-bottom: 10px;
+      border: solid 2px white;
+      background-color: #aed6f1;
+      min-width: 200px;
+      text-align: center;
+  }
+
+  #compile_table .subtable td
+  {
+      min-width: 80px;
+  }
+
+  #compile_table .subtable_title
+  {
+      font-weight: bold;
+  }
+
+  #compile_table .revision_number
+  {
+      font-weight: bold;
+  }
Index: /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/xios_compile.html
===================================================================
--- /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/xios_compile.html	(revision 1773)
+++ /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/xios_compile.html	(revision 1773)
@@ -0,0 +1,293 @@
+<!DOCTYPE html>
+<html>
+    <head>
+        <metacharset="utf-8"/>
+        <link rel="stylesheet" href="xios-style.css"/>
+        <title>XIOS Compile Report - Le Site Web</title>
+        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
+        <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet"/>
+        <script>
+            $(document).ready(function()
+            {
+                $('#content').load("xios_table.html");
+                $('#content2').load("xios_table2.html");
+                $('#txtcont').load("report.html");
+            });
+        </script>
+
+
+    </head>
+    <body>
+        <header>
+            <h1>XIOS Compile Status Web Page</h1>
+            <h2>(still under construction ... ...)</h2>
+        </header>
+        <nav>
+            <div id="navborder">
+                <p id="xiosinfo">Some useful links:</p>
+                <ul>
+                    <li><a href="https://forge.ipsl.jussieu.fr/ioserver/wiki" target="_blank">XIOS wiki page</a></li>
+                    <li><a href="graph.html" target="_blank">Workflow Graph</a></li>
+                    <li><a href="plein_report.txt" target="_blank">Plein Text Report</a>(0:initialized 1:passed -1:failed)</li>
+                </ul> 
+            </div>
+        
+            
+        </nav> 
+        <section>
+            
+            <h2>Table of compile status of XIOS</h2>
+            
+
+            <!-- <div id="content"></div> -->
+
+            <form method="post" style="margin-left: 60px;">
+                    <p><label for="revision">Revision : </label>
+                        
+                        <select name="revision" id="revision">            
+                            <option value="0" selected>Choose a revision ...</option>
+                            <option value="1740">1740</option>
+                            <option value="1741">1741</option>
+                            <option value="1742">1742</option>
+                            <option value="1743">1743</option>
+                        </select>
+                    </p>
+                </form>
+
+            <table id="compile_table">
+                    <thead>
+                        <td><em>Revision</em></td>
+                        <td><em>Irene</em></td>
+                        <td><em>Jean-Zay</em></td>
+                    </thead>
+                    <tfoot>
+                    </tfoot>
+                    <tbody>
+                    <tr class="compile_table_row">
+                        <td class="revision_number">1740</td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch2</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                            </table>
+
+                        </td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                <td class="subtable_title">arch2</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch3</td>
+                                    <td>&#10060;</td>
+                                    <td>&#10060;</td>
+                                </tr>
+                            </table>
+                        </td> 
+                    </tr>
+                    <tr class="compile_table_row">
+                        <td class="revision_number">1741</td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#10060;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch2</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                            </table>
+                        </td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                <td class="subtable_title">arch2</td>
+                                    <td>&#9989;</td>
+                                    <td>&#10060;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch3</td>
+                                    <td>&#10060;</td>
+                                    <td>&#10060;</td>
+                                </tr>
+                            </table>
+                        </td>
+                    </tr>
+                    <tr class="compile_table_row">
+                        <td class="revision_number">1742</td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch2</td>
+                                    <td>&#10060;</td>
+                                    <td>&#10060;</td>
+                                </tr>
+                            </table>
+                        </td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                <td class="subtable_title">arch2</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch3</td>
+                                    <td>&#10060;</td>
+                                    <td>&#10060;</td>
+                                </tr>
+                            </table>
+                        </td>
+                    </tr>
+                    <tr class="compile_table_row">
+                        <td class="revision_number">1743</td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch2</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                            </table>
+                        </td>
+                        <td>
+                            <table class="subtable">
+                                <tr>
+                                    <td style="border: 0px;"></td>
+                                    <td class="subtable_title">Prod</td>
+                                    <td class="subtable_title">Debug</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch1</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                <td class="subtable_title">arch2</td>
+                                    <td>&#9989;</td>
+                                    <td>&#9989;</td>
+                                </tr>
+                                <tr>
+                                    <td class="subtable_title">arch3</td>
+                                    <td>&#10060;</td>
+                                    <td>&#10060;</td>
+                                </tr>
+                            </table>
+                        </td>
+                    </tr>
+                    </tbody>
+                </table>
+
+        </section>
+
+        <body>
+
+        <footer>
+            <p>Copyright XIOS - Tous droits rÃ©servÃ©s
+                <a href="mailto:xios-dev@forge.ipsl.jussieu.fr">Nous contacter !</a>
+            </p>
+        </footer>
+    </body>
+</html>
+
+<script>
+
+$("#revision").change(function() {
+    if(this.value==0)
+    {
+        var $rows = $('.compile_table_row', '#compile_table');    
+        $('.compile_table_row', '#compile_table').css('display', '');
+    }
+    else
+    {
+        // Convert 1-based index to 0 based index
+        var index = this.value - 1740;
+
+        // Select all rows in the table
+        var $rows = $('.compile_table_row', '#compile_table');
+
+        // Set all rows to no background
+        //   $rows.css('background-color', '');
+        $rows.css('display', 'none');
+
+        // Change the selected row's color to one
+        //   $('.row', '.table1').eq(index).css('background-color', 'yellow');
+        $('.compile_table_row', '#compile_table').eq(index).css('display', '');
+    }
+   
+});
+
+</script>