Index: /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/job_jz.sh
===================================================================
--- /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/job_jz.sh	(revision 1778)
+++ /XIOS/dev/dev_trunk_omp/GENERIC_TESTCASE/job_jz.sh	(revision 1779)
@@ -15,11 +15,17 @@
 
 cd ${SLURM_SUBMIT_DIR}
+module unload intel-all hdf5 netcdf netcdf-cxx netcdf-fortran
+module load intel-all/19.0.4
+module load hdf5/1.10.5/intel-19.0.4-mpi
+module load netcdf/4.7.2/intel-19.0.4-mpi
+module load netcdf-cxx/4.2/intel-19.0.4-mpi
+module load netcdf-fortran/4.5.2/intel-19.0.4-mpi
 
-module purge
-module load intel-all/19.0.4
-module load netcdf/4.7.0/intel-19.0.4-mpi
-module load netcdf-cxx/4.2/intel-19.0.4-mpi
-module load netcdf-fortran/4.4.5/intel-19.0.4-mpi
-module load gcc/6.5.0/gcc-4.8.5
+#module purge
+#module load intel-all/19.0.4
+#module load netcdf/4.7.0/intel-19.0.4-mpi
+#module load netcdf-cxx/4.2/intel-19.0.4-mpi
+#module load netcdf-fortran/4.4.5/intel-19.0.4-mpi
+#module load gcc/6.5.0/gcc-4.8.5
 module load cmake
 module load cdo
@@ -105,3 +111,3 @@
 #srun --mpi=pmi2 ../bin/test_client.exe
 
-cp plein_report.txt ../Web/plein_report_$xios_revision.txt
+#cp plein_report.txt ../Web/plein_report_$xios_revision.txt
Index: /XIOS/dev/dev_trunk_omp/arch/arch-X64_JEANZAY.env
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-X64_JEANZAY.env	(revision 1778)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-X64_JEANZAY.env	(revision 1779)
@@ -1,8 +1,16 @@
-module purge
-module load gcc/6.5.0/gcc-4.8.5 
+module unload intel-all hdf5 netcdf netcdf-cxx netcdf-fortran
 module load intel-all/19.0.4
-module load netcdf/4.7.0/intel-19.0.4-mpi
+module load hdf5/1.10.5/intel-19.0.4-mpi
+module load netcdf/4.7.2/intel-19.0.4-mpi
 module load netcdf-cxx/4.2/intel-19.0.4-mpi
-module load netcdf-fortran/4.4.5/intel-19.0.4-mpi
+module load netcdf-fortran/4.5.2/intel-19.0.4-mpi
+
+
+#module purge
+#module load gcc/6.5.0/gcc-4.8.5 
+#module load intel-all/19.0.4
+#module load netcdf/4.7.0/intel-19.0.4-mpi
+#module load netcdf-cxx/4.2/intel-19.0.4-mpi
+#module load netcdf-fortran/4.4.5/intel-19.0.4-mpi
 
 
Index: /XIOS/dev/dev_trunk_omp/doc/XIOS_testcase_user_guide.tex
===================================================================
--- /XIOS/dev/dev_trunk_omp/doc/XIOS_testcase_user_guide.tex	(revision 1778)
+++ /XIOS/dev/dev_trunk_omp/doc/XIOS_testcase_user_guide.tex	(revision 1779)
@@ -172,9 +172,9 @@
 is Juliot-Curie from the TGCC computing center\footnote{\url{http://www-hpc.cea.fr/en/complexe/tgcc-JoliotCurie.htm}}.
 
-Inside the \verb|GENERIC_TESTCASE| folder, we have a sob submission script \verb|job_irene.sh|. 
-This script will execute all the unit tests in all the 5 test folders. We also prepared 
+In the \verb|GENERIC_TESTCASE| folder, we have a job submission script \verb|job_irene.sh|. 
+This script will execute all the unit tests in all 5 test folders. We also prepared 
 job scripts for each test folder. If one want to run unit tests for a specific folder, 
 \textit{e.g.} \verb|test_domain_algo|, it is sufficient to launch the \verb|job_irene.sh| 
-script inside the \verb|test_domain_algo| folder. 
+script inside the folder \verb|test_domain_algo|. 
 
 \section{Output of XIOS testcase}
Index: /XIOS/dev/dev_trunk_omp/inputs/iodef.xml
===================================================================
--- /XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1778)
+++ /XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1779)
@@ -37,5 +37,5 @@
         <!-- <field field_ref="field_C" name="field_C_name"  enabled=".TRUE." />  -->
         <!-- <field id="field_D" field_ref="field_A" operation="instant" build_workflow_graph=".TRUE." name="field_D_name" build_workflow_graph_start="1h" build_workflow_graph_end="2h" > sqrt(field_A) </field> -->
-        <field id="field_D" field_ref="field_A" operation="average" build_workflow_graph=".TRUE." name="field_D"  > field_A + field_B + field_C</field>
+        <field id="field_D" field_ref="field_A" operation="average" build_workflow_graph=".FALSE." name="field_D"  > field_A+1 </field>
         <!-- <field field_ref="field_A_zoom" name="field_B" build_workflow_graph=".TRUE."/> -->
      </file>
@@ -81,7 +81,7 @@
       <variable_definition>
          <variable_group id="server">
-            <variable id="using_server2" type="bool">true</variable>
+            <variable id="using_server2" type="bool">false</variable>
             <variable id="ratio_server2" type="int">50</variable>
-            <variable id="number_pools_server2" type="int">1</variable>
+            <variable id="number_pools_server2" type="int">1</variable> 
          </variable_group>
 
Index: /XIOS/dev/dev_trunk_omp/src/context_server.cpp
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/context_server.cpp	(revision 1778)
+++ /XIOS/dev/dev_trunk_omp/src/context_server.cpp	(revision 1779)
@@ -86,5 +86,5 @@
     MPI_Iprobe(-2, 20,interComm,&flag,&status);
     #else    
-    MPI_Iprobe(MPI_ANY_SOURCE, 20,interComm,&flag,&status);
+    MPI_Iprobe(-2, 20,interComm,&flag,&status);
     #endif
     traceOn();
Index: /XIOS/dev/dev_trunk_omp/src/test/test_omp.f90
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/test/test_omp.f90	(revision 1778)
+++ /XIOS/dev/dev_trunk_omp/src/test/test_omp.f90	(revision 1779)
@@ -172,6 +172,6 @@
     CALL xios_update_calendar(ts)
     CALL xios_send_field("field_A",field_A)
-    CALL xios_send_field("field_B",field_A)
-    CALL xios_send_field("field_C",field_A)
+    !CALL xios_send_field("field_B",field_A)
+    !CALL xios_send_field("field_C",field_A)
     !CALL xios_send_field("field_Axis",axisValue)
     ! CALL xios_send_field("field_Axis",lval)