Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 1785)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 1787)
@@ -93,5 +93,5 @@
       // A condition to make sure that if there is only one client, axis
       // should be considered to be distributed. This should be a temporary solution     
-      distributed |= (1 == CContext::getCurrent()->client->clientSize);
+      distributed |= (1 == CContext::getCurrent()->intraCommSize_);
       return distributed;
    }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 1785)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 1787)
@@ -227,5 +227,5 @@
               (!i_index.isEmpty() && i_index.numElements() == ni_glo*nj_glo));
       bool distributed_glo ;
-      distributed |= (1 == CContext::getCurrent()->client->clientSize);
+      distributed |= (1 == CContext::getCurrent()->intraCommSize_);
 
       return distributed;
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1785)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1787)
@@ -1352,7 +1352,5 @@
     CContext* context = CContext::getCurrent();    
     {
-      CContextClient* client = context->client;
-
-      int rank = client->clientRank;
+      int rank = context->intraCommRank_;
 
       clientDistribution_ = new CDistributionClient(rank, this);
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/domain_algorithm_interpolate.cpp	(revision 1785)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/domain_algorithm_interpolate.cpp	(revision 1787)
@@ -562,6 +562,6 @@
 {
   CContext* context = CContext::getCurrent();
-  CContextClient* client=context->client;
-  int clientRank = client->clientRank;
+  int clientRank = context->intraCommRank_;
+  int nbClient = context-> intraCommSize_;
 
   this->transformationMapping_.resize(1);
@@ -587,5 +587,5 @@
 
   CClientServerMappingDistributed domainIndexClientClientMapping(globalIndexOfDomainDest,
-                                                                 client->intraComm,
+                                                                 context->intraComm_,
                                                                  true);
   CArray<size_t,1> globalIndexInterp(interpMapValue.size());
@@ -599,9 +599,8 @@
   }
 
-  domainIndexClientClientMapping.computeServerIndexMapping(globalIndexInterp, client->clientSize);
+  domainIndexClientClientMapping.computeServerIndexMapping(globalIndexInterp, nbClient);
   const CClientServerMapping::GlobalIndexMap& globalIndexInterpSendToClient = domainIndexClientClientMapping.getGlobalIndexOnServer();
 
   //Inform each client number of index they will receive
-  int nbClient = client->clientSize;
   int* sendBuff = new int[nbClient];
   int* recvBuff = new int[nbClient];
@@ -628,5 +627,5 @@
 
 
-  MPI_Allreduce(sendBuff, recvBuff, nbClient, MPI_INT, MPI_SUM, client->intraComm);
+  MPI_Allreduce(sendBuff, recvBuff, nbClient, MPI_INT, MPI_SUM, context->intraComm_);
 
   int* sendIndexDestBuff = new int [sendBuffSize];
@@ -661,5 +660,5 @@
              itMap->first,
              MPI_DOMAIN_INTERPOLATION_DEST_INDEX,
-             client->intraComm,
+             context->intraComm_,
              &sendRequest.back());
     sendRequest.push_back(MPI_Request());
@@ -669,5 +668,5 @@
              itMap->first,
              MPI_DOMAIN_INTERPOLATION_SRC_INDEX,
-             client->intraComm,
+             context->intraComm_,
              &sendRequest.back());
     sendRequest.push_back(MPI_Request());
@@ -677,5 +676,5 @@
              itMap->first,
              MPI_DOMAIN_INTERPOLATION_WEIGHT,
-             client->intraComm,
+             context->intraComm_,
              &sendRequest.back());
     sendOffSet += k;
@@ -696,5 +695,5 @@
              MPI_ANY_SOURCE,
              MPI_DOMAIN_INTERPOLATION_DEST_INDEX,
-             client->intraComm,
+             context->intraComm_,
              &recvStatus);
 
@@ -708,5 +707,5 @@
              clientSrcRank,
              MPI_DOMAIN_INTERPOLATION_SRC_INDEX,
-             client->intraComm,
+             context->intraComm_,
              &recvStatus);
 
@@ -716,5 +715,5 @@
              clientSrcRank,
              MPI_DOMAIN_INTERPOLATION_WEIGHT,
-             client->intraComm,
+             context->intraComm_,
              &recvStatus);
 