Index: XIOS/trunk/xios_test_suite/COMPILE/config_compile.py
===================================================================
--- XIOS/trunk/xios_test_suite/COMPILE/config_compile.py	(revision 1820)
+++ XIOS/trunk/xios_test_suite/COMPILE/config_compile.py	(revision 1821)
@@ -67,5 +67,5 @@
             
             f.write("add_test( NAME "+build_dir_name+'\n')
-            f.write("          COMMAND bash -c \"source ../ARCH/arch-"+configs_arg[0][i]+".env  && cd ../.. && ./make_xios --arch_path `pwd`/xios_test_suite/ARCH --arch "+configs_arg[0][i]+" --"+configs_arg[1][j]+" --job 16 --build_dir xios_test_suite/BUILD/build_"+build_dir_name+" | tail -n 1 >> xios_test_suite/COMPILE/build_"+revision+"_"+machine+"_"+build_dir_name+".txt\")\n\n")
+            f.write("          COMMAND bash -c \"source ../ARCH/arch-"+configs_arg[0][i]+".env  && cd ../.. && ./make_xios --arch_path `pwd`/xios_test_suite/ARCH --arch "+configs_arg[0][i]+" --"+configs_arg[1][j]+" --job 16 --build_dir xios_test_suite/BUILD/build_"+build_dir_name+" | echo $? >> xios_test_suite/COMPILE/build_"+revision+"_"+machine+"_"+build_dir_name+".txt\")\n\n")
             f.write("set_tests_properties( "+build_dir_name+" PROPERTIES\n")
             f.write("                      FAIL_REGULAR_EXPRESSION \"failed\")\n\n")
Index: XIOS/trunk/xios_test_suite/COMPILE/generate_compile.py
===================================================================
--- XIOS/trunk/xios_test_suite/COMPILE/generate_compile.py	(revision 1820)
+++ XIOS/trunk/xios_test_suite/COMPILE/generate_compile.py	(revision 1821)
@@ -85,7 +85,7 @@
                 myBuild[3] = myText
 
-            elif line.startswith("Build command"):
-                myTexts = line.replace("Build command ", "").replace("\n", "").split(" ")
-                if myTexts[0] == "finished" :
+            elif line[0].isdigit():
+                myTexts = line.replace("\n", "")
+                if myTexts == "0" :
                     myBuild[4] = "&#9989;" 
                 else :
Index: XIOS/trunk/xios_test_suite/HTML/generate_test_table.js
===================================================================
--- XIOS/trunk/xios_test_suite/HTML/generate_test_table.js	(revision 1820)
+++ XIOS/trunk/xios_test_suite/HTML/generate_test_table.js	(revision 1821)
@@ -189,4 +189,19 @@
   mySubTable.setAttribute("class", "test_sub_table")
   mySubTable.setAttribute("id", "test_sub_table_"+revision+"_"+machine+"_"+build_dir)
+
+  if(info_list.length == 0)
+  {
+    myRow = document.createElement("tr")
+    myRow.setAttribute("id","test_sub_table_row_"+revision+"_"+machine+"_"+build_dir)
+    myRow.setAttribute("class","test_sub_table_row_"+revision+"_"+machine)
+    myRow.classList.add("build_level")
+    myCell = document.createElement("td")
+    myCell.innerHTML = build_dir.replace("build_","")+" Build Failed"
+    myCell.style.color = "white"
+    myCell.style.fontWeight = "bold"
+    myRow.appendChild(myCell)
+    mySubTable.append(myRow)
+    return;
+  }
 
   myRow = document.createElement("tr")
Index: XIOS/trunk/xios_test_suite/HTML/xios-style.css
===================================================================
--- XIOS/trunk/xios_test_suite/HTML/xios-style.css	(revision 1820)
+++ XIOS/trunk/xios_test_suite/HTML/xios-style.css	(revision 1821)
@@ -86,4 +86,8 @@
 }
 
+.showit 
+{
+    display: block;
+}
 
 .compile_table
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/generate_test.py
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/generate_test.py	(revision 1820)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/generate_test.py	(revision 1821)
@@ -63,9 +63,4 @@
                 if not relurl in relurl_list :
                     relurl_list.append(relurl)
-#            elif line.startswith("#machine") :
-#                machine = line.replace("\n","").split(" ")[1]
-#                machine_name = machine_name_dict[machine]
-#                if not machine in machine_list :
-#                    machine_list.append(machine)
             elif line.startswith("#build_dir") :
                 build_dir = line.replace("\n","").split(" ")[1]
@@ -126,6 +121,6 @@
                 f.write("        [\'"+myReportDict[key][j][0]+"\', \'"+myReportDict[key][j][1]+"\', \'"+myReportDict[key][j][2]+"\', "+myReportDict[key][j][3]+"],\n")
             else :
-                f.write("        [\'"+myReportDict[key][j][0]+"\', \'"+myReportDict[key][j][1]+"\', \'"+myReportDict[key][j][2]+"\', "+myReportDict[key][j][3]+"]]\n")
-        f.write("\n\n")
+                f.write("        [\'"+myReportDict[key][j][0]+"\', \'"+myReportDict[key][j][1]+"\', \'"+myReportDict[key][j][2]+"\', "+myReportDict[key][j][3]+"]")
+        f.write("]\n\n\n")
 
     for revision in revision_list :