Index: /XIOS/trunk/xios_test_suite/ENV_local/irene.env
===================================================================
--- /XIOS/trunk/xios_test_suite/ENV_local/irene.env	(revision 1824)
+++ /XIOS/trunk/xios_test_suite/ENV_local/irene.env	(revision 1824)
@@ -0,0 +1,14 @@
+module load subversion
+module load cmake
+
+#CHMOD() { chmod --quiet ug+rwx,o+rx "$@" ;}
+CHMOD() { }
+export -f CHMOD
+
+export xios_full_machine_name="Irene"
+export xios_test_suite_repository=${CCCWORKDIR}/XIOS_TEST_SUITE_REPOSITORY
+#export xios_thredds_dir=/ccc/work/cont003/thredds/p86yann/XIOS_TEST_SUITE
+export xios_reference_dir=${CCCWORKDIR}/XIOS_TEST_SUITE_REPOSITORY
+
+mkdir -p $xios_test_suite_repository ; CHMOD $xios_test_suite_repository
+mkdir -p $xios_thredds_dir ; CHMOD $xios_thredds_dir
Index: /XIOS/trunk/xios_test_suite/ENV_local/jeanzay.env
===================================================================
--- /XIOS/trunk/xios_test_suite/ENV_local/jeanzay.env	(revision 1824)
+++ /XIOS/trunk/xios_test_suite/ENV_local/jeanzay.env	(revision 1824)
@@ -0,0 +1,10 @@
+module load subversion
+module load cmake
+
+CHMOD() { setfacl -R -m u::rwx,u:rpsl565:rwx,u:rpsl954:rwx,u:rgzi016:rwx,g::r-x,o::r-x,m::rwx "$@" ;}
+export -f CHMOD
+
+export xios_full_machine_name="Jean-Zay"
+export xios_test_suite_repository=${WORK}/XIOS_TEST_SUITE_REPOSITORY
+export xios_reference_dir=${WORK}
+mkdir -p $xios_test_suite_repository ; CHMOD $xios_test_suite_repository
Index: /XIOS/trunk/xios_test_suite/HTML/xios_report_local.html
===================================================================
--- /XIOS/trunk/xios_test_suite/HTML/xios_report_local.html	(revision 1824)
+++ /XIOS/trunk/xios_test_suite/HTML/xios_report_local.html	(revision 1824)
@@ -0,0 +1,358 @@
+<!DOCTYPE html>
+<html>
+    <head>
+        <metacharset="utf-8"/>
+        <link rel="stylesheet" href="xios-style.css"/>
+        <title>XIOS Unit Tests Report - Le Site Web</title>
+        
+        <script src="generate_compile_table.js" type="text/javascript"></script>
+        <script src="generate_test_table.js" type="text/javascript"></script>
+
+        <script src="../COMPILE/compile_irene_info.js" type="text/javascript"></script>
+        <script src="../RUN_TEST_SUITE/_test_irene_info.js" type="text/javascript"></script>
+
+        <script src="../COMPILE/compile_jeanzay_info.js" type="text/javascript"></script>
+        <script src="../RUN_TEST_SUITE/_test_jeanzay_info.js" type="text/javascript"></script>
+
+    </head>
+
+    <body onload="generateCompileTable(); generateTestTable(); ">
+        
+        <header>
+            <h1>XIOS Unit Tests Report Web Page</h1>
+            <!-- <h2>(still under construction ... ...)</h2> -->
+        </header>
+
+        <nav>
+            <div>
+                <!-- <p id="xiosinfo">Some useful links:</p> -->
+                <ul>
+                    <li><a href="https://forge.ipsl.jussieu.fr/ioserver/wiki" target="_blank">XIOS wiki page</a></li>
+                    <li><a href="graph.html" target="_blank">Workflow Graph Visualizer</a></li>
+                </ul> 
+            </div>        
+        </nav> 
+
+    
+
+        <section>
+
+            <!-- <h2>Results of unit tests</h2> -->
+
+            <form method="post" style="margin-left: 25px;">
+
+                <p><label for="Build revision">Choose a revision number to show compile and test results : </label>
+                    <select name="revision" id="revision">
+                        <option value="0" selected>All available revisions ...</option>
+                    </select>
+                </p>
+
+            </form>
+
+
+            <ul><li>&#10060; : compile failed / test failed</li><li>&#10062; : test result initialized</li><li>&#9989; : compile passed / test passed</li></ul>
+
+        </section>
+
+        <section>
+
+
+            <div>
+                <table id="compile_table" style="margin: 50px;">
+                    <caption>Table of XIOS Compile status</caption>
+                    <tr style="font-weight: bold;" id="compile_table_row0"></tr>
+                </table>
+            </div>    
+
+
+            <div style="margin-top: 100px;">
+                <table id="test_table" style="margin: 50px;">
+                    <caption>Table of XIOS unit tests results</caption>
+                    <tr style="font-weight: bold;" id="test_table_row0"></tr>
+                </table>
+            </div>
+
+
+        </section>
+
+
+        <footer>
+            <p>Copyright XIOS - Tous droits rÃ©servÃ©s
+                <a href="mailto:xios-dev@forge.ipsl.jussieu.fr">Nous contacter !</a>
+            </p>
+        </footer>
+    </body>
+</html>
+ 
+<script>
+
+    var params = "scrollbars=yes,resizable=no,status=no,location=no,toolbar=no,menubar=no,width=600,height=300,left=100,top=100";
+
+    function show_text(the_text) 
+    {
+        window.open("about:blank", "", params).document.write(the_text);  
+    }
+
+    function show_user_params(machine, revision, build_dir, algo)
+    {
+        var user_params = eval("test_"+machine+"_"+revision+"_"+algo+"_user_params")
+        var myText = "<p style=\"color:blue;font-weight:bold;\">user_params.def for "+algo+"</p><p>"
+        for (var i=0; i<user_params.length; i++)
+        {
+            myText += user_params[i]+"</br>"
+        }
+        myText+="</p>"
+        window.open("about:blank", "", params).document.write(myText);
+    }
+
+    function show_all_params(machine, revision, build_dir, algo, config)
+    {
+        var config_name = config.replace(/=/g,"_")
+        var all_params = eval("test_"+machine+"_"+revision+"_"+algo+"_"+config_name+"_all_params")
+        var myText = "<p style=\"color:blue;font-weight:bold;\">all_param.def for "+algo+"/"+config+"</p><p>"
+        for (var i=0; i<all_params.length; i++)
+        {
+            myText += all_params[i]+"</br>"
+        }
+        myText+="</p>"
+        window.open("about:blank", "", params).document.write(myText); 
+    }
+
+
+    function show_plain_report(machine, revision, build_dir)
+    {
+        var info_list = eval("test_"+machine+"_"+revision+"_"+build_dir.replace("build_",""))
+        var myText = "<p style=\"color:blue;\">Revision = "+revision+"</br>Machine = "+machine+"<br>Build_dir ="+build_dir+"</p>"
+        for (var i=0; i<info_list.length; i++)
+        {
+            myText+="<P>"
+            for (var j=0; j<4; j++)
+            {
+                myText+=info_list[i][j]+" "
+            }
+            myText+="</p>"
+        }
+        window.open("about:blank", "", params).document.write(myText);
+    }
+    
+    function show_dropdown(dropdown_id)
+    {
+        var cell = document.getElementById(dropdown_id);
+        if (cell)
+        {
+            cell.classList.add("showit")
+        }
+    }
+
+    function hide_dropdown(dropdown_id)
+    {
+        var cell = document.getElementById(dropdown_id);
+        if (cell)
+        {
+            cell.classList.remove("showit")
+        }
+    }
+    
+    
+</script>
+
+
+<script>
+
+    document.getElementById("revision").addEventListener("change", myFunction);
+    
+    function myFunction() 
+    {
+        if(this.value == 0)
+        {
+            // compile part ...
+
+            var ans = document.getElementsByClassName('compile_table_row')
+            for (var i = 0; i < ans.length; i++)
+            {
+                cell = ans[i]
+                cell.classList.remove('hide')
+                cell.classList.add('show')
+            }
+            document.getElementById("empty_compile_row").style.display="none"
+
+            // test part ...
+
+            var ans = document.getElementsByClassName('test_table_row')
+            for (var i = 0; i < ans.length; i++)
+            {
+                cell = ans[i]
+                cell.classList.remove('hide')
+                cell.classList.add('show')
+            }
+            document.getElementById("empty_test_row").style.display="none"
+        }
+        
+        else
+        {
+            // compile part ...
+
+            var ans = document.getElementsByClassName('compile_table_row')
+            for (var i = 0; i < ans.length; i++)
+            {
+                cell = ans[i]
+                cell.classList.remove('show')
+                cell.classList.add('hide')
+            }
+            document.getElementById("empty_compile_row").style.display="none"
+
+            var ans = document.getElementById('compile_table_'+this.value)
+            if(ans)
+            {
+                ans.classList.remove('hide')
+                ans.classList.add('show')
+            } 
+            else
+            {
+                document.getElementById("empty_compile_row_revision").innerHTML=this.value
+                document.getElementById("empty_compile_row").style.display="table-row"
+            } 
+
+            
+            // test part ...
+            
+            var ans = document.getElementsByClassName('test_table_row')
+            for (var i = 0; i < ans.length; i++)
+            {
+                cell = ans[i]
+                cell.classList.remove('show')
+                cell.classList.add('hide')
+            }
+            document.getElementById("empty_test_row").style.display="none"
+            
+            var ans = document.getElementById('test_table_'+this.value)
+            if(ans)
+            {
+                ans.classList.remove('hide')
+                ans.classList.add('show')
+            } 
+            else
+            {
+                document.getElementById("empty_test_row_revision").innerHTML=this.value
+                document.getElementById("empty_test_row").style.display="table-row"
+            } 
+        }
+    }
+</script>
+
+
+<script>
+
+    function level0_toggle(machine, my_revision) {
+        var level1_ans = document.getElementsByClassName('table_'+machine+'_'+my_revision+"_build_level")
+        for (var i = 0; i < level1_ans.length; i++) 
+        {
+            var cell = level1_ans[i]
+            if (cell.style.display != 'table-row')
+            {
+                cell.style.display = 'table-row'
+            }
+            else
+            {
+                cell.style.display = 'none'
+            }
+
+            buildType = cell.getAttribute("data-build-type");
+            var level2_ans = document.getElementsByClassName(buildType+"_algo_level")
+            for (var j = 0; j < level2_ans.length; j++)
+            {
+                var cell = level2_ans[j]
+                cell.style.display = 'none'
+                algoType = cell.getAttribute("data-algo-type");
+                var level3_ans =  document.getElementsByClassName(algoType+"_config_level")
+                for (var k = 0; k < level3_ans.length; k++)
+                {
+                    var cell = level3_ans[k]
+                    cell.style.display = 'none'
+                    configType = cell.getAttribute("data-config-type")
+                    var level4_ans = document.getElementsByClassName(configType+"_file_level")
+                    for (var h = 0; h<level4_ans.length; h++) 
+                    {
+                        level4_ans[h].style.display = "none"
+                    }
+                }
+            }    
+        }
+    }
+
+
+
+    function level1_toggle(machine, my_revision, build_dir) {
+        var level2_ans = document.getElementsByClassName('table_'+machine+'_'+my_revision+"_"+build_dir+"_algo_level")
+        for (var i = 0; i < level2_ans.length; i++) 
+        {
+            var cell = level2_ans[i]
+            if (cell.style.display != 'table-row')
+            {
+                cell.style.display = 'table-row'
+            }
+            else
+            {
+                cell.style.display = 'none'
+            }
+            algoType = cell.getAttribute("data-algo-type")
+            var level3_ans = document.getElementsByClassName(algoType+"_config_level")
+            for (var j = 0; j < level3_ans.length; j++)
+            {
+                var cell = level3_ans[j]
+                cell.style.display = 'none'
+                configType = cell.getAttribute("data-config-type")
+                var level4_ans = document.getElementsByClassName(configType+"_file_level")
+                for (var k = 0; k<level4_ans.length; k++) 
+                {
+                    level4_ans[k].style.display = "none"
+                }
+            }
+        }
+    }
+
+
+
+    function level2_toggle(machine, my_revision, build_dir, algo_name) {
+        var level3_ans = document.getElementsByClassName('table_'+machine+'_'+my_revision+"_"+build_dir+"_"+algo_name+"_config_level")
+        for (var i = 0; i < level3_ans.length; i++) 
+        {
+            var cell = level3_ans[i]
+            if (cell.style.display != 'table-row')
+            {
+                cell.style.display = 'table-row'   
+            }
+            else
+            {
+                cell.style.display = 'none'
+            }
+            configType = cell.getAttribute("data-config-type")
+            var level4_ans = document.getElementsByClassName(configType+"_file_level")
+            for (var j = 0; j<level4_ans.length; j++) 
+            {
+                level4_ans[j].style.display = "none"
+            }
+        }
+    }
+
+
+    function level3_toggle(machine, my_revision, build_dir, algo_name, config_name) {
+        var level4_ans = document.getElementsByClassName('table_'+machine+'_'+my_revision+"_"+build_dir+"_"+algo_name+"_"+config_name+"_file_level")
+        for (var i = 0; i < level4_ans.length; i++) 
+        {
+            var cell = level4_ans[i]
+            if (cell.style.display != 'table-row')
+            {
+                cell.style.display = 'table-row'
+            }
+            else
+            {
+                cell.style.display = 'none'
+            }
+        }
+    }
+
+    
+
+</script>
+
Index: /XIOS/trunk/xios_test_suite/TEST_SUITE/check.py
===================================================================
--- /XIOS/trunk/xios_test_suite/TEST_SUITE/check.py	(revision 1823)
+++ /XIOS/trunk/xios_test_suite/TEST_SUITE/check.py	(revision 1824)
@@ -216,9 +216,5 @@
 
 		f=open("checkfile.def", "r")
-		h=open("report.txt", "a+")
-		l=open("report.html", "a+")
-		preport=open("../plein_report.txt", "a+")
-		h.write("Config : "+configName+"\n")		
-		l.write("<p>Config : "+configName+"</p>")	
+		preport=open("../plain_report.txt", "a+")
 		for line in f:
 			line=line.strip()
@@ -232,7 +228,5 @@
 						OSinfo(cmd)	
 				
-				h.write("test for "+lpurple("all NC files")+"     \t"+yellow('INITIALIZED')+"\n")
 				preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"_all_nc_files"+" "+repr(0)+" \n")				
-				l.write("<p>test for <font color=\"purple\">"+"all NC files"+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"darkorange\">INITIALIZED</font></p>")
 				print yellow("\n        ****************************************")
 				print yellow("        ** "+"all NC files"+" is stored as temporal reference !!! **")
@@ -245,7 +239,5 @@
 				OSinfo(cmd)
 
-				h.write("test for "+lpurple(line)+"     \t"+yellow('INITIALIZED')+"\n")		
 				preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"@"+line+" "+repr(0)+" \n")		
-				l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"darkorange\">INITIALIZED</font></p>")
 				print yellow("\n        ****************************************")
 				print yellow("        ** "+line+" is stored as temporal reference !!! **")
@@ -253,8 +245,4 @@
 				
 		f.close()
-		h.write("\n")
-		l.write("<br>")
-		h.close()
-		l.close()
 		preport.close()
 		#generate job scripts
@@ -299,11 +287,6 @@
 		
 		f=open("checkfile.def", "r")
-		h=open("report.txt", "a+")
-		l=open("report.html", "a+")
-		preport=open("../plein_report.txt", "a+")
-
-
-		h.write("Config : "+configName+"\n")	
-		l.write("<p>Config : "+configName+"</p>")	
+		preport=open("../plain_report.txt", "a+")
+
 		for line in f:
 
@@ -319,7 +302,5 @@
 						
 						if os.stat("diff.txt").st_size==0:
-							h.write("test for "+lpurple(thisfile)+"     \t"+green('PASSED')+"\n")		
 							preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"@"+thisfile+" "+repr(1)+" \n")		
-							l.write("<p>test for <font color=\"purple\">"+thisfile+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
 							print green("\n        ****************************************")
 							print green("        ** "+thisfile+" is valid !!! **")
@@ -330,14 +311,10 @@
 							for gline in g:
 								if gline.strip().startswith("0") or ":" in gline :
-									h.write("test for "+lpurple(thisfile)+"      \t"+green('PASSED')+"\n")	
 									preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"@"+thisfile+" "+repr(1)+" \n")			
-									l.write("<p>test for <font color=\"purple\">"+thisfile+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
 									print green("\n        ****************************************")
 									print green("        ** "+thisfile+" is valid !!! **")
 									print green("\n        ****************************************")
 								else:
-									h.write("test for "+lpurple(thisfile)+"     \t"+red('FAILED')+"\n")	
 									preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"@"+thisfile+" "+repr(-1)+" \n")			
-									l.write("<p>test for <font color=\"purple\">"+thisfile+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"red\">FAILED</font></p>")		
 									print red("\n        **************************************************")
 									print red("        ** "+thisfile+" is NOT valid. Please debugging.. **")
@@ -367,7 +344,5 @@
 
 				if os.stat("diff.txt").st_size==0:
-					h.write("test for "+lpurple(line)+"     \t"+green('PASSED')+"\n")
 					preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"@"+line+" "+repr(1)+" \n")				
-					l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
 					print green("\n        ****************************************")
 					print green("        ** "+line+" is valid !!! **")
@@ -378,14 +353,10 @@
 					for gline in g:
 						if gline.strip().startswith("0") or ":" in gline :
-							h.write("test for "+lpurple(line)+"      \t"+green('PASSED')+"\n")		
 							preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"@"+line+" "+repr(1)+" \n")		
-							l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"green\">PASSED</font></p>")		
 							print green("\n        ****************************************")
 							print green("        ** "+line+" is valid !!! **")
 							print green("\n        ****************************************")
 						else:
-							h.write("test for "+lpurple(line)+"     \t"+red('FAILED')+"\n")	
 							preport.write(os.path.basename(os.getcwd())+" "+os.path.basename(os.getcwd())[5:]+"@"+configName+" "+os.path.basename(os.getcwd())[5:]+"@"+configName[7:]+"@"+line+" "+repr(-1)+" \n")			
-							l.write("<p>test for <font color=\"purple\">"+line+"</font> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font color=\"red\">FAILED</font></p>")		
 							print red("\n        **************************************************")
 							print red("        ** "+line+" is NOT valid. Please debugging.. **")
@@ -409,8 +380,4 @@
 
 		f.close()
-		h.write("\n")
-		l.write("<br>")
-		h.close()
-		l.close()
 		preport.close()
 
Index: /XIOS/trunk/xios_test_suite/TEST_SUITE/run_sub_test.sh
===================================================================
--- /XIOS/trunk/xios_test_suite/TEST_SUITE/run_sub_test.sh	(revision 1823)
+++ /XIOS/trunk/xios_test_suite/TEST_SUITE/run_sub_test.sh	(revision 1824)
@@ -8,14 +8,4 @@
 
 
-# Black        0;30     Dark Gray     1;30
-# Red          0;31     Light Red     1;31
-# Green        0;32     Light Green   1;32
-# Brown/Orange 0;33     Yellow        1;33
-# Blue         0;34     Light Blue    1;34
-# Purple       0;35     Light Purple  1;35
-# Cyan         0;36     Light Cyan    1;36
-# Light Gray   0;37     White         1;37
-
-
 { nb_proc=$(python sub_config.py 2>&1 1>&3-) ;} 3>&1
 
@@ -25,8 +15,4 @@
     echo "build_dir="$build_dir
     ccc_mprun -n $nb_proc $xios_dir/$build_dir/bin/generic_testcase.exe
-elif [[($machine_name == ada)]]
-then
-    echo "Testing on ADA"
-    mpirun -np $nb_proc $xios_dir/$build_dir/bin/generic_testcase.exe
 elif [[($machine_name == jeanzay)]]
 then
Index: /XIOS/trunk/xios_test_suite/TEST_SUITE/run_test
===================================================================
--- /XIOS/trunk/xios_test_suite/TEST_SUITE/run_test	(revision 1823)
+++ /XIOS/trunk/xios_test_suite/TEST_SUITE/run_test	(revision 1824)
@@ -2,14 +2,14 @@
 
 source ../ARCH/arch-${arch}.env
-cd .. ; source load_env ; cd RUN_TEST_SUITE 
+cd .. ; source load_env_local ; cd RUN_TEST_SUITE 
 
 export machine_name=$xios_machine_name
 export machine_full_name=$xios_full_machine_name
 export xios_dir=$(bash -c "cd ../.. && pwd" 2>&1)
-export reference_dir=${xios_reference_dir}
+
 export reference_file=xios_reference.tar.gz
 export reference_folder=xios_reference
 
-export build_dir=build_${arch}_${mode}
+export build_dir=xios_test_suite/RUN_TEST_SUITE/build_${arch}_${mode}
 export xios_revision=$(svn info --show-item revision ../.. 2>&1)
 export relurl=$(svn info --show-item relative-url ../.. 2>&1)
@@ -20,7 +20,8 @@
 
 bash -c "cd ../.. && ./make_xios --arch_path `pwd`/../ARCH --arch ${arch} --${mode} --build_dir ${build_dir} --job 16"
+export build_status=$?
 
 #----------- Fetch reference -----------
-cp ${reference_dir}/${reference_file} ./
+cp ${xios_reference_dir}/${reference_file} ./
 tar -xzvf ${reference_file}
 
@@ -37,13 +38,15 @@
 
 
-rm -f plein_report.txt
+rm -f plain_report.txt
 
-echo "#revision" ${xios_revision} >> plein_report.txt
-echo "#relurl" ${relurl} >> plein_report.txt
-echo "#machine" ${machine_name} >> plein_report.txt
-echo "#build_dir" ${xios_dir}/${build_dir} >> plein_report.txt
-echo "#arch" ${arch} >> plein_report.txt
-echo "#mode" ${mode} >> plein_report.txt
+echo "#revision" ${xios_revision} >> plain_report.txt
+echo "#relurl" ${relurl} >> plain_report.txt
+echo "#machine" ${machine_name} >> plain_report.txt
+echo "#build_dir" ${xios_dir}/${build_dir} >> plain_report.txt
+echo "#arch" ${arch} >> plain_report.txt
+echo "#mode" ${mode} >> plain_report.txt
 
+if [[ ${build_status} == 0 ]]
+then
 
 rm -f setup.sh
@@ -88,5 +91,5 @@
 mkdir -p ${rundir}/test_${machine_name} ; CHMOD ${xios_test_suite_repository}/test_${machine_name}
 
-cp plein_report.txt ${rundir}/test_${machine_name}/test_${xios_revision}_${machine_name}_${arch}_${mode}.txt
+cp plain_report.txt ${rundir}/test_${machine_name}/test_${xios_revision}_${machine_name}_${arch}_${mode}.txt
 CHMOD ${rundir}/test_${machine_name}/test_${xios_revision}_${machine_name}_${arch}_${mode}.txt
 
@@ -106,2 +109,4 @@
 done
 
+fi
+
Index: /XIOS/trunk/xios_test_suite/TEST_SUITE/run_test_jeanzay_local
===================================================================
--- /XIOS/trunk/xios_test_suite/TEST_SUITE/run_test_jeanzay_local	(revision 1824)
+++ /XIOS/trunk/xios_test_suite/TEST_SUITE/run_test_jeanzay_local	(revision 1824)
@@ -0,0 +1,5 @@
+#!/bin/bash
+
+sbatch --wait job_jeanzay.sh 
+
+bash -c "python generate_test.py"
Index: /XIOS/trunk/xios_test_suite/launch_all_local
===================================================================
--- /XIOS/trunk/xios_test_suite/launch_all_local	(revision 1824)
+++ /XIOS/trunk/xios_test_suite/launch_all_local	(revision 1824)
@@ -0,0 +1,5 @@
+#!/bin/bash
+
+source ./load_env_local
+./launch_compile_local
+./launch_test_suite_local
Index: /XIOS/trunk/xios_test_suite/launch_compile_local
===================================================================
--- /XIOS/trunk/xios_test_suite/launch_compile_local	(revision 1824)
+++ /XIOS/trunk/xios_test_suite/launch_compile_local	(revision 1824)
@@ -0,0 +1,5 @@
+#!/bin/bash
+
+source ./load_env_local
+mkdir -p BUILD
+(cd COMPILE && ./compile_${xios_machine_name}_local)
Index: /XIOS/trunk/xios_test_suite/launch_test_suite_local
===================================================================
--- /XIOS/trunk/xios_test_suite/launch_test_suite_local	(revision 1824)
+++ /XIOS/trunk/xios_test_suite/launch_test_suite_local	(revision 1824)
@@ -0,0 +1,6 @@
+#!/bin/bash
+
+source ./load_env_local
+mkdir -p RUN_TEST_SUITE
+cp -r TEST_SUITE/* RUN_TEST_SUITE
+(cd RUN_TEST_SUITE && ./run_test_${xios_machine_name}_local)