Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_irene
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_irene	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_irene	(revision 1846)
@@ -3,6 +3,9 @@
 set -x 
 
-export revision=$(svn info --show-item revision .. 2>&1)
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
 
+if (( ${server_revision} >= ${revision} ))
+then
 python config_compile.py
 
@@ -19,2 +22,6 @@
 
 copy_to_thredds compile_${xios_machine_name}_info.js
+
+else
+echo "latest revision ... no need to compile"
+fi
Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_irene_local
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_irene_local	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_irene_local	(revision 1846)
@@ -3,6 +3,9 @@
 set -x 
 
-export revision=$(svn info --show-item revision .. 2>&1)
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
 
+if (( ${server_revision} >= ${revision} ))
+then
 python config_compile.py
 
@@ -18,2 +21,5 @@
 bash -c "python ./generate_compile.py"
 
+else 
+echo "latest revision ... no need to compile"
+fi
Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_jeanzay
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_jeanzay	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_jeanzay	(revision 1846)
@@ -1,5 +1,10 @@
 #!/bin/bash
-set -x 
-export revision=$(svn info --show-item revision .. 2>&1)
+
+#set -x 
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
+
+if (( ${server_revision} >= ${revision} ))
+then
 python config_compile.py
 
@@ -15,3 +20,6 @@
 bash -c "python ./generate_compile.py"
 copy_to_forge compile_${xios_machine_name}_info.js
+else
 
+echo "latest revision ... no need to compile"
+fi
Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_jeanzay_local
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_jeanzay_local	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/COMPILE/compile_jeanzay_local	(revision 1846)
@@ -1,6 +1,10 @@
 #!/bin/bash
 set -x 
-echo ${xios_root}
-export revision=$(svn info --show-item revision ${xios_root} 2>&1)
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
+
+if (( ${server_revision} >= ${revision} ))
+then
+
 python config_compile.py
 
@@ -15,4 +19,6 @@
 
 bash -c "python ./generate_compile.py"
-# copy_to_forge compile_${xios_machine_name}_info.js
+else 
 
+echo "latest revision ... no need to compile"
+fi
Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_irene
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_irene	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_irene	(revision 1846)
@@ -1,4 +1,7 @@
 #!/bin/bash
-
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
+if (( ${server_revision} >= ${revision} ))
+then
 ccc_msub -E "--wait" job_irene.sh 
 
@@ -7,2 +10,9 @@
 copy_to_thredds  test_${xios_machine_name}_info.js
 mv test_${xios_machine_name}_info.js _test_${xios_machine_name}_info.js
+
+else
+echo "latest version ... no need to test"
+
+fi
+
+
Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_irene_local
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_irene_local	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_irene_local	(revision 1846)
@@ -1,5 +1,13 @@
 #!/bin/bash
-
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
+if (( ${server_revision} >= ${revision} ))
+then
 ccc_msub -E "--wait" job_irene_local.sh 
 
 bash -c "python generate_test.py"
+else
+echo "latest version ... no need to test"
+
+fi
+
Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_jeanzay
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_jeanzay	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_jeanzay	(revision 1846)
@@ -1,4 +1,7 @@
 #!/bin/bash
-
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
+if (( ${server_revision} >= ${revision} ))
+then
 sbatch --wait job_jeanzay.sh 
 
@@ -7,2 +10,9 @@
 copy_to_forge  test_${xios_machine_name}_info.js
 mv test_${xios_machine_name}_info.js _test_${xios_machine_name}_info.js
+
+else
+echo "latest version ... no need to test"
+
+fi
+
+
Index: /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_jeanzay_local
===================================================================
--- /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_jeanzay_local	(revision 1845)
+++ /XIOS/dev/dev_trunk_omp/xios_test_suite/TEST_SUITE/run_test_jeanzay_local	(revision 1846)
@@ -1,5 +1,13 @@
 #!/bin/bash
 
+export revision=$(svn info --show-item revision ../.. 2>&1)
+export server_revision=$(svn info --show-item last-changed-revision http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/dev/dev_trunk_omp 2>&1)
+if (( ${server_revision} >= ${revision} ))
+then
 sbatch --wait job_jeanzay_local.sh 
 
 bash -c "python generate_test.py"
+else
+echo "latest version ... no need to test"
+
+fi